/*************************************************************************
I2C/TWI FUNCTIONS - I2C/TWI FUNCTIONS - I2C/TWI FUNCTIONS - I2C/TWI FUNCTIONS 
**************************************************************************/

void I2C_INIT();

void I2C_START();

void I2C_RESTART();

void I2C_STOP();

char I2C_TRANSMIT_BYTE(char Data);

char I2C_RECEIVE_BYTE(char Last);

void I2C_SEND_MESSAGE(char Device_ID, char AddrH, char Data);

char I2C_RECEIVE_MESSAGE(char Device_ID, char AddrH);

/*************************************************************************
LCD FUNCTIONS - LCD FUNCTIONS - LCD FUNCTIONS - LCD FUNCTIONS 
**************************************************************************/

void LCD03_SET_CURSOR(char FCL_CURSOR);

void LCD03_CLEAR_SCREEN();

void LCD03_BACKLIGHT_ON();

void LCD03_BACKLIGHT_OFF();

void LCD_WRITE_STRING(  const unsigned char *  pString );

void LCD03_WRITE_INT(int ii);

void LCD03_WRITE_BYTE(char ii);

void LCD03_CLEAR_LINE(char line); // line 0-1-2-3

/*************************************************************************
STRING FUNCTIONS - STRING FUNCTIONS - STRING FUNCTIONS - STRING FUNCTIONS 
**************************************************************************/

unsigned char STR_LEN( const char *p );

bit STR_EQUAL( const char *p, const char *q );

bit STR_PREFIX( const char *p, const char *q );

void STR_COPY( char *p, unsigned char s, char *q, unsigned char n );

bit CHAR_IN( char c, const char * s );

bit STRING_IN( const char * p, const char * q );

/*************************************************************************
RS232/UART FUNCTIONS - RS232/UART FUNCTIONS - RS232/UART FUNCTIONS 
**************************************************************************/

void UART_INIT_1200( void );
void UART_INIT_2400( void );
void UART_INIT_4800( void );
void UART_INIT_9600( void );
void UART_INIT_19200( void );
void UART_INIT_57600( void );
void UART_INIT_115200( void );
void UART_INIT_250000( void );


bit UART_CHAR_AVAILABLE( void );

char UART_CHAR_RECEIVE( void );

bit UART_SEND_IDLE( void );

void UART_CHAR_SEND( char c );

void UART_STRING_SEND( const char *p );

void UART_STRING_RECEIVE( 
   char *received,
   unsigned char received_size, 
   unsigned int milliseconds, 
   const char * terminate,
   const char * ignore 
);	

/*************************************************************************
ADC FUNCTIONS - ADC FUNCTIONS - ADC FUNCTIONS - ADC FUNCTIONS 
**************************************************************************/

unsigned int READ_ADC_INT_CHANNEL( unsigned char channel );


unsigned char READ_ADC_BYTE_CHANNEL( unsigned char channel );