#include <htc.h>			
#include "PIC_PROTON_LIB.h"	 
#define _XTAL_FREQ  19660800 
__CONFIG(0x2ff2);  // set HS Xtal etc
__CONFIG(0x3fff);

void main()
{
// init AD & Option reg
ANSEL = 0;
ANSELH = 0;
OPTION = 0xC0;
// end of init
__delay_ms(250);
__delay_ms(250); //wait for stable power supply

I2C_INIT(); // initialize I2C - LCD03 is a I2C LCD
    volatile unsigned char ENC=0, VOLT=0;
    I2C_SEND_MESSAGE(0xB0,16,50); // Disable 2 sec timeout in command reg
	TRISB |=0b00110000; //B4-B5 input - SWITCHES

    while (1)
        {
        VOLT = I2C_RECEIVE_MESSAGE(0xB0,10);
        LCD03_CLEAR_SCREEN();
        LCD03_SET_CURSOR(1);
		char String[20] = "BATT_VOLT: ";
		LCD_WRITE_STRING(String);
        LCD03_WRITE_BYTE(VOLT);

        if (PORTB & 0b00010000)  //red switch
            {
            I2C_SEND_MESSAGE(0xB0,16,32); //clear all encoder registers
            I2C_SEND_MESSAGE(0xB0,0,121);
            I2C_SEND_MESSAGE(0xB0,1,121);
            ENC = 255;
            __delay_ms(30); // When read to fast - value is still 0
                while (ENC > 165) // wheels turn backwards - encoder counts back
                    { 
                    ENC = I2C_RECEIVE_MESSAGE(0xB0,2); // always dummy read high byte fist - this buffers the 4 enc regs
                    ENC = I2C_RECEIVE_MESSAGE(0xB0,5); // low byte
                    LCD03_SET_CURSOR(43);
					char enc[20] = "ENCOD: ";
					LCD_WRITE_STRING(enc);
                    LCD03_WRITE_BYTE(ENC);
                   }
  
            }
        else if (PORTB & 0b00100000) //black switch 
            {
            I2C_SEND_MESSAGE(0xB0,16,32); //clear all encoder registers
            I2C_SEND_MESSAGE(0xB0,0,135); // Slow forward
            I2C_SEND_MESSAGE(0xB0,1,135);
            ENC = 0;
              while (ENC < 90) // wheels turn forward - encoder increments
                    { 
                    ENC = I2C_RECEIVE_MESSAGE(0xB0,2); // always dummy read high byte fist - this buffers the 4 enc regs
                    ENC = I2C_RECEIVE_MESSAGE(0xB0,5); // low byte
                    LCD03_SET_CURSOR(43);
					char enc[20] = "ENCOD: ";
					LCD_WRITE_STRING(enc);
                    LCD03_WRITE_BYTE(ENC);
                    }
            }
        else
            {
            I2C_SEND_MESSAGE(0xB0,0,128); // stop wheels
            I2C_SEND_MESSAGE(0xB0,1,128);
            }
        }
}


  